<?php
function unitrack_getclicky_settings_form() {

  $form['#redirect'] = 'admin/settings/unitrack';
  $form['unitrack_getclicky_site_id_number'] = array(
    '#type' => 'textfield',
    '#title' => t('Site ID Number'),
    '#default_value' => variable_get('unitrack_getclicky_site_id_number', ''),
    '#size' => 15,
    '#maxlength' => 20,
    '#required' => TRUE,
    '#description' => t('Example input: 130169<br>
    This number is unique to every website you track via Clicky(a.k.a. GetClicky).<br>
    - If you <b>do not</b> have an account with Clicky - you can obtain one from the <a href="@url1">GetClicky</a> website. (clicking on this link shows your support for my development of this module - especially if you decide to buy a Pro account with Clicky. Here is <a href="http://getclicky.com/#theotherguys">why</a> and here is <a href="http://getclicky.com/help/pricing">accounts comparison</a>)<br>
    - If you <b>DO</b> have a Clicky account - you can find that number here:<br>
      - anywhere you see a link like that <a href="@url2">http://getclicky.com/<b>130169</b></a> - take only the number - this is your Clicky site ID number.
      - you can find this in your affiliate link (if you have many sites tracked by one Clicky user account - the affiliate link uses the 1st site\'s ID), <br>
      - also in your tracking code and in your site prefs page ...
    
    ', 
    array('@url1' => 'http://getclicky.com/130169', '@url2' => 'http://getclicky.com/130169')  ),
    );

  $form['unitrack_getclicky_site_key_number'] = array(
    '#type' => 'textfield',
    '#title' => t('Site Key Number'),
    '#default_value' => variable_get('unitrack_getclicky_site_key_number', ''),
    '#size' => 100,
    '#maxlength' => 100,
    '#required' => FALSE,
    '#description' => t('Example input: 72543da7406597242<br>
    This number is an API key used to display stats on the <a hre"">page</a>.'),
    );
   
  $form['submit'] = array(
    '#type' => 'submit', 
    '#value' => t('Save settings'),
  );
  
  return $form;
}

function unitrack_getclicky_settings_form_submit($form, &$form_state) {
  variable_set('unitrack_getclicky_site_id_number', $form_state['values']['unitrack_getclicky_site_id_number']);
  variable_set('unitrack_getclicky_site_key_number', $form_state['values']['unitrack_getclicky_site_key_number']); 
}