<?php
function unitrack_tracker() {
  $args = func_get_args();
  $op = empty($args[0]) ? 'track' : $args[0];
  
  switch ($op) {
    case 'nojs.png':
      drupal_set_header('Content-Type: image/png');
      echo file_get_contents(drupal_get_path('module', 'unitrack') . '/nojs.png');
      $fout = fopen('/tmp/unitrack', 'a');
      fwrite($fout, time() . ' ' . print_r($_SERVER, 1) . print_r($_SESSION, 1) . print_r($_REQUEST, 1) . "\r\n");
      fclose($fout);
      return;
      break;
    case 'action':
    default:
      $q = db_query('SELECT * FROM {unitrack_events}');
      $tracked_events = array();
      while ($row = db_fetch_array($q)) {
        $tracked_events[$row['event_id']][] = $row['type_id'];
      }
     
      $visitor_id = 0;
      $visitor_data = array();      
      $out = array();
      $existing = '';      // Retrieve user data if present.
      if (empty($_REQUEST['vid']) && !empty($_COOKIE['visitor_id'])) {
        $_REQUEST['vid'] = $_COOKIE['visitor_id'];
      }
      if (!empty($_REQUEST['vid'])) {
        $splitted = explode(',', $_REQUEST['vid']);
        if (count($splitted) == 2) {
          $visitor_id = intval($splitted[0]);
          if ($visitor_id > 0) {
            $existing = db_fetch_array(db_query('SELECT uuid, data FROM {unitrack_visitors} WHERE vid = %d', $visitor_id));
          }
          // Recreate old visitor.
          if ($visitor_id > 0 && empty($existing) && preg_match('/[0-9a-z]{8}-[0-9a-z]{4}-[0-9a-z]{4}-[0-9a-z]{4}-[0-9a-z]{12}/', $splitted[1])) {
            db_query("INSERT INTO {unitrack_visitors} (vid, uuid, created) VALUES (%d, '%s', NOW()", $visitor_id, $splitted[1]);
            $existing == array('vid' => $visitor_id, 'uuid' => $splitted[1]);
          }
          if (!empty($existing['data'])) {
            $visitor_data = unserialize($existing['data']);
          }
          else {
            $visitor_data = array();
          }
          $vuuid = $splitted[1];
        }
      }      
      if ($visitor_id <= 0) {
        list($visitor_id, $vuuid) = unitrack_new_visitor();
      }
      $out['visitor'] = $visitor_id . ',' . $vuuid;
      $session_id = 0; // Retrieve session data if present.
      if (!empty($_REQUEST['sid'])) {
        $splitted = explode(',', $_REQUEST['sid']);
        if (count($splitted) == 2) {
          $session_id = intval($splitted[0]);
          if ($session_id > 0) {
            $existing = db_result(db_query('SELECT uuid FROM {unitrack_visits} WHERE vid = %d', $session_id));
          }
          if ($existing != $splitted[1]) {
            $existing == '';
            $session_id = 0;
          }
          else {
            db_query('UPDATE {unitrack_visits} SET visit_end = NOW() WHERE vid = %d', $session_id);
          }
        }
      }
      if ($session_id <= 0) {
        list($session_id, $suuid) = unitrack_new_session($visitor_id, $_POST);
        $out['session'] = $session_id . ',' . $suuid;
      }
      $out['tracked_events'] = $tracked_events;
      // Modules should returned only changed key/value pairs to minimize memory consumption.
      $additions = module_invoke_all('unitrack', $out);
      if (is_array($additions) && is_array($visitor_data) && count($additions)) {
        $visitor_data = array_merge($visitor_data, $additions);
        $safe_string = iconv('UTF-8', 'UTF-8//IGNORE', serialize($visitor_data));
        if ($GLOBALS['db_type'] == 'pgsql') {
          $safe_string = preg_replace('/\'/', '\'\'', $safe_string); 
        }
        else {
          $safe_string = preg_replace('/\'/', '\\\'', $safe_string);
        }
        // Note that serialized data cannot be passed as %s, because db_escape_string is too strict.
        db_query("UPDATE {unitrack_visitors} SET data = '$safe_string' WHERE vid = %d", $visitor_id);
      }
      if ($visitor_data) {
        $out['visitor_data'] = $visitor_data;
      }
      _unitrack_session_data($out);
      drupal_set_header('Content-type:text/javascript');
      echo drupal_json($out);
      $request_type = empty($_REQUEST['type']) ? 'Page View' : check_plain($_REQUEST['type']);
      db_query("INSERT INTO {unitrack_actions} (visit_id, type, address, timestamp) VALUES (%d, '%s', '%s', NOW())",
        $session_id, $request_type, substr(addslashes($_REQUEST['path']), 0, 255));
  }
  
  $workers_loaded = $_SESSION['unitrack_loaders'];
  $defaults = array(
    'workers' => array('self'),
  );
}

function unitrack_generate_uuid() {
  // The field names refer to RFC 4122 section 4.1.2.
  $uuid = sprintf('%04x%04x-%04x-4%03x-%04x-%04x%04x%04x', 
    mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
    mt_rand(0, 65535), // 16 bits for "time_mid"
    mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
    bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)),'01', 6, 2)), // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
    // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
    // 8 bits for "clk_seq_low"
    mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"
    );
  return $uuid; 
}

// Return array 
function unitrack_new_visitor($set_cookie = TRUE) {
  $uuid = unitrack_generate_uuid();
  db_query("INSERT INTO {unitrack_visitors} (uuid, created) VALUES ('%s', NOW())", $uuid);
  $vid = db_last_insert_id('unitrack_visitors', 'vid');
  if ($set_cookie && (empty($_COOKIE['unitrack_vid']) || $_COOKIE['unitrack_vid'] != "$vid,$uuid")) {
    setcookie('unitrack_vid', "$vid,$uuid", time() + 8640000, '/', $GLOBALS['cookie_domain']);
    $_COOKIE['unitrack_vid'] = "$vid,$uuid";
  }
  return array($vid, $uuid);
}

function unitrack_new_session($visitor_id, $data, $set_cookie = TRUE) {
  $uuid = unitrack_generate_uuid();
  $data['ua'] = isset($data['ua']) ? substr($data['ua'],0,250) : 'unknown';
  $data['resolution'] = isset($data['resolution']) ? $data['resolution'] : 'unknown';
  $data['os'] = isset($data['os']) ? $data['os'] : 'unknown';
  $data['flash_version'] = isset($data['flash_version']) ? $data['flash_version'] : 'unknown';
  $data['js_enabled'] = isset($data['js_enabled']) ? intval($data['js_enabled']) : (-1);
  $data['java_enabled'] = isset($data['java_enabled']) ? intval($data['java_enabled']) : (-1);
  if (key_exists('HTTP_X_REAL_IP', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_REAL_IP'];
  } elseif (key_exists('HTTP_X_FORWARDED_FOR', $_SERVER)) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } elseif(isset($_SERVER['REMOTE_ADDR'])) {
    $ip = $_SERVER['REMOTE_ADDR'];
  }
  $data['ip'] = isset($data['ip']) ? $data['ip'] : $ip;
  db_query("INSERT INTO {unitrack_visits} (visitor_id, uuid, visit_start, visit_end, user_agent, resolution, os, flash_version, js_enabled, java_enabled,ip)
   VALUES (%d, '%s', NOW(), NOW(), '%s', '%s', '%s', '%s', %d, %d, '%s')", $visitor_id, $uuid, 
   $data['ua'], $data['resolution'], $data['os'], $data['flash_version'], $data['js_enabled'], $data['java_enabled'], $data['ip']);
  $sid = db_last_insert_id('unitrack_visits', 'vid');
  
  if ($set_cookie && (empty($_COOKIE['unitrack_sid']) || $_COOKIE['unitrack_sid'] != "$sid,$uuid")) {
    setcookie('unitrack_sid', "$sid,$uuid", 0, '/', $GLOBALS['cookie_domain']);
    $_COOKIE['unitrack_sid'] = "$sid,$uuid";
  }
  
  return array($sid, $uuid);
}